#include <AltSoftSerial.h>
AltSoftSerial mySerial;

char toSend[4];
byte toRead[36];
byte toRecieve[4];
boolean measureState;
int i,len;
signed long tmp;
double m[8];
int num_ions=8;

void setup() 
{
  measureState = false;
  Serial.begin(9600); // pc serial
  mySerial.begin(9600); //meter serial
}

void loop() 
{ 
 Serialreceive(); 
 while (measureState == true)
 {
    rebre_Dades();
  delay(10);
 }
 delay(10);
}
void Serialreceive()
{
  if (Serial.available()>0) 
  { 
    Serial.readBytes(toRecieve, 4);    // get the new byte:
    if (toRecieve[0]==0x4D) //Mesurar 1 'M'
    {
      toSend[0] = 0x02;    // the value 02 represents the measure instruction.
      toSend[1] = 0x00;
      toSend[2] = 0x00;
      toSend[3] = 0x00;
      for(int i=0;i<4;i++)
      {
        mySerial.print(toSend[i]);
      }
      measureState=true;
      Serial.println("Measuring ...");
    }
  }
}

void rebre_Dades()
{
  if (mySerial.available()>0) 
  {
    
    len = mySerial.readBytes(toRead,36 );
    Serial.print("HEX code: ");
    for (i=0; i<len; i++)
    {
      
      Serial.print(toRead[i], HEX);
      Serial.print(" ");
    }  
    if (toRead[0]==0x01 && toRead[1]==0x02 && toRead[34]==0x03 && toRead[35]==0x04)// 
    {
      for (i = 0; i < num_ions; i++) 
          {
            tmp = toRead[2 + 4 * i]; // int tmp
            tmp <<= 8;
            tmp |= toRead[3 + 4 * i];
            tmp <<= 8;
            tmp |= toRead[4 + 4 * i];
            tmp <<= 8;
            tmp |= toRead[5 + 4 * i];
            m[i] = ((double)tmp/100.00);

            Serial.println();
            Serial.print("ION number ");
            Serial.print(i+1);
            Serial.print("\t");
            Serial.print("value: ");
            Serial.print(m[i], 2);
            Serial.print(" mV");     
          }
         measureState=false;
         Serial.println();
     }
  }
}




